#include <stdarg.h>
#include <stdio.h>
#include <time.h>
#include "loadsscvf.h"
#include "service.h"

VOID AddToEventLog(WORD type, LPSTR lpszMsg, ...)
{
    HANDLE  hEventSource;
    char buf[1024];
    va_list marker;
    LPSTR  lpszStrings[2];

_TRY_EXCEPTION_BLOCK_BEGIN()

    va_start(marker, lpszMsg);
    vsprintf(buf, lpszMsg, marker);
    va_end(marker);

    printf("%s", buf);

    lpszStrings[0] = buf;
    hEventSource = RegisterEventSource(NULL, TEXT(SZSERVICENAME));

    if (hEventSource != NULL) {
        ReportEvent(hEventSource, // handle of event source
            type,                 // event type
            0,                    // event category
            1,                    // event ID
            NULL,                 // current user's SID
            1,                    // strings in lpszStrings
            0,                    // no bytes of raw data
            lpszStrings,          // array of error strings
            NULL);                // no raw data

        (VOID) DeregisterEventSource(hEventSource);
    }

_TRY_EXCEPTION_BLOCK_END(1)

    return;
}

